package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.agraham.reflection.Reflection _r = null;
public anywheresoftware.b4a.samples.httputils2.httpjob _http = null;
public static int _cid = 0;
public static int _lac = 0;
public anywheresoftware.b4a.randomaccessfile.RandomAccessFile _raf1 = null;
public anywheresoftware.b4a.agraham.byteconverter.ByteConverter _bc = null;
public static byte[] _mydata = null;
public anywheresoftware.b4a.samples.httputils2.httputils2service _httputils2service = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 34;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 87;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 89;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 43;BA.debugLine="r.Target = r.GetContext";
mostCurrent._r.Target = (Object)(mostCurrent._r.GetContext(processBA));
 //BA.debugLineNum = 44;BA.debugLine="r.Target = r.RunMethod2(\"getSystemService\", \"phone\", \"java.lang.String\")";
mostCurrent._r.Target = mostCurrent._r.RunMethod2("getSystemService","phone","java.lang.String");
 //BA.debugLineNum = 45;BA.debugLine="r.Target = r.RunMethod(\"getCellLocation\")";
mostCurrent._r.Target = mostCurrent._r.RunMethod("getCellLocation");
 //BA.debugLineNum = 46;BA.debugLine="cid = r.RunMethod(\"getCid\")";
_cid = (int)(BA.ObjectToNumber(mostCurrent._r.RunMethod("getCid")));
 //BA.debugLineNum = 47;BA.debugLine="lac = r.RunMethod(\"getLac\")";
_lac = (int)(BA.ObjectToNumber(mostCurrent._r.RunMethod("getLac")));
 //BA.debugLineNum = 50;BA.debugLine="If File.Exists(File.DirRootExternal, \"tmp_out.dat\") Then";
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"tmp_out.dat")) { 
 //BA.debugLineNum = 51;BA.debugLine="File.Delete(File.DirRootExternal, \"tmp_out.dat\")";
anywheresoftware.b4a.keywords.Common.File.Delete(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"tmp_out.dat");
 };
 //BA.debugLineNum = 54;BA.debugLine="raf1.Initialize( File.DirRootExternal, \"tmp_out.dat\", False)";
mostCurrent._raf1.Initialize(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"tmp_out.dat",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 55;BA.debugLine="raf1.WriteShort(21,raf1.CurrentPosition)";
mostCurrent._raf1.WriteShort((short) (21),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 56;BA.debugLine="raf1.WriteLong(0,raf1.CurrentPosition)";
mostCurrent._raf1.WriteLong((long) (0),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 57;BA.debugLine="WriteUTF(raf1,\"en\")";
_writeutf(mostCurrent._raf1,"en");
 //BA.debugLineNum = 58;BA.debugLine="WriteUTF(raf1,\"Android\")";
_writeutf(mostCurrent._raf1,"Android");
 //BA.debugLineNum = 59;BA.debugLine="WriteUTF(raf1,\"1.0\")";
_writeutf(mostCurrent._raf1,"1.0");
 //BA.debugLineNum = 60;BA.debugLine="WriteUTF(raf1,\"Web\")";
_writeutf(mostCurrent._raf1,"Web");
 //BA.debugLineNum = 61;BA.debugLine="raf1.WriteByte(27,raf1.CurrentPosition)";
mostCurrent._raf1.WriteByte((byte) (27),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 62;BA.debugLine="raf1.WriteInt(0,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt((int) (0),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 63;BA.debugLine="raf1.WriteInt(0,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt((int) (0),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 64;BA.debugLine="raf1.WriteInt(3,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt((int) (3),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 65;BA.debugLine="WriteUTF(raf1,\"\")";
_writeutf(mostCurrent._raf1,"");
 //BA.debugLineNum = 66;BA.debugLine="raf1.WriteInt(cid,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt(_cid,mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 67;BA.debugLine="raf1.WriteInt(lac,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt(_lac,mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 68;BA.debugLine="raf1.WriteInt(0,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt((int) (0),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 69;BA.debugLine="raf1.WriteInt(0,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt((int) (0),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 70;BA.debugLine="raf1.WriteInt(0,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt((int) (0),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 71;BA.debugLine="raf1.WriteInt(0,raf1.CurrentPosition)";
mostCurrent._raf1.WriteInt((int) (0),mostCurrent._raf1.CurrentPosition);
 //BA.debugLineNum = 72;BA.debugLine="raf1.Flush";
mostCurrent._raf1.Flush();
 //BA.debugLineNum = 73;BA.debugLine="raf1.Close";
mostCurrent._raf1.Close();
 //BA.debugLineNum = 76;BA.debugLine="MyData = Bit.InputStreamToBytes( File.OpenInput(File.DirRootExternal, \"tmp_out.dat\") )";
_mydata = anywheresoftware.b4a.keywords.Common.Bit.InputStreamToBytes((java.io.InputStream)(anywheresoftware.b4a.keywords.Common.File.OpenInput(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"tmp_out.dat").getObject()));
 //BA.debugLineNum = 82;BA.debugLine="Http.Initialize(\"http\",Me)";
mostCurrent._http._initialize(processBA,"http",main.getObject());
 //BA.debugLineNum = 83;BA.debugLine="Http.PostBytes(\"http://www.google.com/glm/mmap\", MyData )";
mostCurrent._http._postbytes("http://www.google.com/glm/mmap",_mydata);
 //BA.debugLineNum = 85;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        anywheresoftware.b4a.samples.httputils2.httputils2service._process_globals();
main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Private r As Reflector";
mostCurrent._r = new anywheresoftware.b4a.agraham.reflection.Reflection();
 //BA.debugLineNum = 26;BA.debugLine="Private Http As HttpJob";
mostCurrent._http = new anywheresoftware.b4a.samples.httputils2.httpjob();
 //BA.debugLineNum = 27;BA.debugLine="Private cid, lac As Int";
_cid = 0;
_lac = 0;
 //BA.debugLineNum = 28;BA.debugLine="Private raf1 As RandomAccessFile";
mostCurrent._raf1 = new anywheresoftware.b4a.randomaccessfile.RandomAccessFile();
 //BA.debugLineNum = 29;BA.debugLine="Private BC As ByteConverter";
mostCurrent._bc = new anywheresoftware.b4a.agraham.byteconverter.ByteConverter();
 //BA.debugLineNum = 30;BA.debugLine="Private MyData() As Byte";
_mydata = new byte[(int) (0)];
;
 //BA.debugLineNum = 32;BA.debugLine="End Sub";
return "";
}
public static String  _jobdone(anywheresoftware.b4a.samples.httputils2.httpjob _job) throws Exception{
anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper _out = null;
 //BA.debugLineNum = 91;BA.debugLine="Sub JobDone (Job As HttpJob)";
 //BA.debugLineNum = 92;BA.debugLine="If Job.Success = True Then";
if (_job._success==anywheresoftware.b4a.keywords.Common.True) { 
 //BA.debugLineNum = 95;BA.debugLine="Dim out As OutputStream = File.OpenOutput(File.DirRootExternal, \"tmp_in.dat\", False)";
_out = new anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper();
_out = anywheresoftware.b4a.keywords.Common.File.OpenOutput(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"tmp_in.dat",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 96;BA.debugLine="File.Copy2(Job.GetInputStream, out)";
anywheresoftware.b4a.keywords.Common.File.Copy2((java.io.InputStream)(_job._getinputstream().getObject()),(java.io.OutputStream)(_out.getObject()));
 //BA.debugLineNum = 97;BA.debugLine="out.Close";
_out.Close();
 //BA.debugLineNum = 100;BA.debugLine="MyData = Bit.InputStreamToBytes( File.OpenInput(File.DirRootExternal, \"tmp_in.dat\") )";
_mydata = anywheresoftware.b4a.keywords.Common.Bit.InputStreamToBytes((java.io.InputStream)(anywheresoftware.b4a.keywords.Common.File.OpenInput(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"tmp_in.dat").getObject()));
 //BA.debugLineNum = 101;BA.debugLine="ToastMessageShow( BC.StringFromBytes(MyData, \"UTF8\"),True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(mostCurrent._bc.StringFromBytes(_mydata,"UTF8"),anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 104;BA.debugLine="ToastMessageShow(\"Error: \" & Job.ErrorMessage, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error: "+_job._errormessage,anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 106;BA.debugLine="Job.Release";
_job._release();
 //BA.debugLineNum = 107;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _writeutf(anywheresoftware.b4a.randomaccessfile.RandomAccessFile _raf,String _s) throws Exception{
byte[] _b = null;
 //BA.debugLineNum = 109;BA.debugLine="Sub WriteUTF(raf As RandomAccessFile, s As String)";
 //BA.debugLineNum = 110;BA.debugLine="Dim b() As Byte = s.GetBytes(\"UTF8\")";
_b = _s.getBytes("UTF8");
 //BA.debugLineNum = 111;BA.debugLine="raf.WriteShort(b.Length, raf.CurrentPosition)";
_raf.WriteShort((short) (_b.length),_raf.CurrentPosition);
 //BA.debugLineNum = 112;BA.debugLine="raf.WriteBytes(b, 0, b.Length, raf.CurrentPosition)";
_raf.WriteBytes(_b,(int) (0),_b.length,_raf.CurrentPosition);
 //BA.debugLineNum = 113;BA.debugLine="End Sub";
return "";
}
}
